
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

/*
 * bb_array_s
 */

%%define array
%name "bb_array_s"
%type "bool"
%%end

/*
 * ui_array_s
 * p_first_set_s
 * p_follow_set_s
 * p_sem_const_array_types_s
 */

%%define array
%name "ui_array_s"
%name "p_first_set_s"
%name "p_follow_set_s"
%name "p_sem_const_array_types_s"
%type "unsigned"
%function "bool set_compare(ui_array_s &second);"
%function "void add_to_set(p_follow_set_s &add_set);"
%%end

//************************* REGULAR ******************************

/*
 * reg_mul_state_move_s
 */

%%define set
%name "reg_mul_state_move_s"
%type "unsigned short"
   %variable "move_char"
%type "unsigned"
   %variable "from_state"
%type "ui_array_s"
   %variable "mul_state"
%%end

/*
 * reg_mul_state_move_array_s
 */

%%define array
%name "reg_mul_state_move_array_s"
%type "reg_mul_state_move_s"
%function "unsigned get_idx_by_move_char(unsigned short a_move_char);"
%%end

/*
 * reg_mul_state_move_queue_s
 */

%%define queue
%name "reg_mul_state_move_queue_s"
%type "reg_mul_state_move_s"
%%end

/*
 * reg_mul_state_map_s
 */

%%define set
%name "reg_mul_state_map_s"
%type "ui_array_s"
   %variable "mul_state"
%type "unsigned"
   %variable "dka_state_idx"
%%end

/*
 * reg_mul_state_map_array_s
 */

%%define array
%name "reg_mul_state_map_array_s"
%type "reg_mul_state_map_s"
%function "unsigned get_idx_by_mul_state(ui_array_s &a_mul_state);"
%%end

//*********************************************************

/*
 * bc_array_s
 * ascii_reg_exp_s
 */

%%define array
%name "bc_array_s"
%name "ascii_reg_exp_s"
%type "char"
%%end

/*
 * bc_arrays_s
 * ascii_reg_exps_s
 */

%%define array
%name "bc_arrays_s"
%name "ascii_reg_exps_s"
%type "ascii_reg_exp_s"
%%end

/*
 * string_array_s
 * p_terminal_names_s
 * p_sem_variable_names_s
 */

%%define array
%name "string_array_s"
%name "p_terminal_names_s"
%name "p_sem_variable_names_s"
%type "string_s"
%function "unsigned get_char_ptr_idx(unsigned a_length,char *a_data);"
%%end

// --- lexical definitions ---

/*
 * fa_state_move_s
 */

%%define map
%name "reg_state_move_s"
%name "fa_state_move_s"
%type "unsigned short"
%type "unsigned"
%%end

/*
 * fa_state_moves_s
 */

%%define array
%name "reg_state_moves_s"
%name "fa_state_moves_s"
%type "fa_state_move_s"
%%end

/*
 * fa_state_moves_array_s
 */

%%define array
%name "fa_state_moves_array_s"
%type "fa_state_moves_s"
%%end

/*
 * us_array_s
 * ushort_reg_exp_s
 */

%%define array
%name "us_array_s"
%name "ushort_reg_exp_s"
%type "unsigned short"
%function "inline void process_reg_exp_char(char **c_ptr);";
%function "void load_ascii_reg_exp(ascii_reg_exp_s &a_reg_exp);"
%function "void load_char_ptr_reg_exp(char *reg_exp);"
%function "bool next_chars(unsigned reg_pos,fa_state_moves_s &ret_chars,ui_array_s &stack);"
%%end

/*
 * ushort_reg_exps_s
 */

%%define array
%name "ushort_reg_exps_s"
%type "ushort_reg_exp_s"
%function "void load_ascii_reg_exps(ascii_reg_exps_s &a_reg_exps);"
%function "void load_char_ptrs_reg_exps(unsigned reg_exp_cnt,char **reg_exps);"
%%end

/*
 * fa_state_s
 */

%%define set
%name "fa_state_s"
%type "unsigned"
   %variable "final"
%type "fa_state_moves_s"
   %variable "moves"
%%end

/*
 * fa_states_s
 */

%%define array
%name "fa_states_s"
%type "fa_state_s"
%%end

/*
 * fa_states_array_s
 */

%%define array
%name "fa_states_array_s"
%type "fa_states_s"
%%end

/*
 * reg_state_s
 * p_kernel_rule_dot_s
 * p_kernel_goto_s
 * pcs_state_position_s
 */

%%define set
%name "reg_state_s"
%name "p_kernel_rule_dot_s"
%name "p_kernel_goto_s"
%name "pcs_state_position_s"
%type "unsigned"
   %variable "ui_first"
%type "unsigned"
   %variable "ui_second"
%%end

/*
 * reg_states_s
 * p_kernel_rule_dots_s
 * p_kernel_gotos_s
 * pcs_state_position_s
 */

%%define array
%name "reg_states_s"
%name "p_kernel_rule_dots_s"
%name "p_kernel_gotos_s"
%name "pcs_state_positions_s"
%type "reg_state_s"
%%end

/*
 * fa_state_descr_s
 */

%%define set
%name "fa_state_descr_s"
%type "unsigned"
   %variable "from_state_id"
%type "unsigned short"
   %variable "with_char"
%type "reg_states_s"
   %variable "reg_states"
%%end

/*
 * fa_state_descrs_s
 */

%%define array
%name "fa_state_reg_states_s"
%type "reg_states_s"
%%end

/*
 * fa_state_descr_queue_s
 */

%%define queue
%name "fa_state_descr_queue_s"
%type "fa_state_descr_s"
%%end

/*
 * ui_arrays_s
 * p_first_sets_s
 * p_follow_sets_s
 * p_rule_idxs_sets_s
 */

%%define array
%name "ui_arrays_s"
%name "p_first_sets_s"
%name "p_follow_sets_s"
%name "p_rule_idxs_sets_s"
%type "p_first_set_s"
%%end

/*
 * final_automata_s
 */

%%define set
%name "final_automata_s"
%type "unsigned"
   %variable "state_idx"
%type "fa_states_s"
   %variable "states"
%type "ui_arrays_s"
   %variable "state_moves"
%function "void create(ushort_reg_exps_s &reg_exps);"
%function "void create_new(fa_states_array_s &states_array);"
%function "unsigned recognize(char *input,unsigned &input_idx,unsigned input_length,unsigned &line_cnt);"
%%end

// --- parser definitions ---

/*
 * p_terminal_s
 */

%%define map
%name "p_terminal_s"
%type "string_s"
%type "string_s"
%%end

/*
 * p_terminals_s
 */

%%define array
%name "p_terminals_s"
%type "p_terminal_s"
%function "unsigned get_char_ptr_idx(unsigned a_length,char *a_data);"
%%end

/*
 * p_nonterminal_s
 */

%%define set
%name "p_nonterminal_s"
%type "string_s"
   %variable "name"
%%end

/*
 * p_nonterminals_s
 */

%%define array
%name "p_nonterminals_s"
%type "p_nonterminal_s"
%function "unsigned get_char_ptr_idx(unsigned a_length,char *a_data);"
%%end

/*
 * p_rule_s
 */

%%define set
%name "p_rule_s"
%type "unsigned"
   %variable "head"
%type "ui_array_s"
   %variable "body"
%type "string_s"
   %variable "sem_prog"
%%end

/*
 * p_rules_s
 */

%%define array
%name "p_rules_s"
%type "p_rule_s"
%%end

/*
 * p_first_rules_sets_s
 */

%%define array
%name "ui_arrays_array_s"
%name "p_first_rules_sets_s"
%type "p_rule_idxs_sets_s"
%%end

/*
 * p_kernel_s
 */

%%define set
%name "p_kernel_s"
%type "p_kernel_rule_dots_s"
   %variable "rule_dots"
%type "p_kernel_gotos_s"
   %variable "gotos"
%%end

/*
 * p_kernels_s
 */

%%define array
%name "p_kernels_s"
%type "p_kernel_s"
%function "unsigned get_idx_by_rule_dots(p_kernel_s &a_value);"
%%end

/*
 * p_lalr_table_s
 */

%%define double_array
%name "p_lalr_table_s"
%type "unsigned"
%%end

/*
 * pcd_final_automata_set_s
 */

%%define set
%name "pcd_final_automata_set_s"
%type "final_automata_s"
   %variable "rule_file_fa"
%type "final_automata_s"
   %variable "key_terminals_fa"
%fundef "save_file"
%fundef "load_file"
%%end

/*
 * p_creat_descr_s
 */

%%define set
%name "p_creat_descr_s"
%type "pcd_final_automata_set_s"
   %variable "final_automata_set"
%type "string_s"
   %variable "init_sem_prog"
%type "p_terminals_s"
   %variable "terminals"
%type "p_nonterminals_s"
   %variable "nonterminals"
%type "p_rules_s"
   %variable "rules"
%type "p_first_sets_s"
   %variable "firsts"
%type "p_first_rules_sets_s"
   %variable "first_rules"
%type "p_follow_sets_s"
   %variable "follows"
%type "p_kernels_s"
   %variable "kernels"
%function "inline bool load_final_automata_set(char *file_name);"
%function "inline bool load_final_automata_set_new(const char *file_name);"
%function "bool load_from_rule_char_ptr(unsigned a_length,char *a_data);"
%function "inline bool load_from_rule_string(string_s &rule_string);"
%function "void find_key_terminals(unsigned &end_terminal,ui_array_s &skip_terminals);"
%function "void create_final_automata(final_automata_s &final_automata);"
%function "void create_final_automata_new(final_automata_s &final_automata);"
%function "void compute_firsts();"
%function "bool compute_follows_of_nonterminal(unsigned nonterm_idx,bb_array_s &follows_created,ui_array_s &nonterm_used,p_follow_set_s &ret_follows);"
%function "void compute_follows();"
%function "void compute_kernels();"
%function "void create_lalr_table(p_lalr_table_s &lalr_table);"
%%end

/*
 * reg_lalr_stack_element_s
 * p_sem_rule_descr_s
 * p_lalr_stack_element_s
 */

%%define set
%name "reg_lalr_stack_element_s"
%name "p_sem_rule_descr_s"
%name "p_lalr_stack_element_s"
%type "unsigned"
   %variable "ui_first"
%type "unsigned"
   %variable "ui_second"
%type "unsigned"
   %variable "ui_third"
%%end

/*
 * reg_lalr_stack_s
 * p_sem_rule_descrs_s
 * p_lalr_stack_s
 */

%%define array
%name "reg_lalr_stack_s"
%name "p_sem_rule_descrs_s"
%name "p_lalr_stack_s"
%type "p_sem_rule_descr_s"
%function "inline void push(unsigned a_ui_first);"
%function "inline void push(unsigned a_ui_first,unsigned a_ui_second,unsigned a_ui_third);"
%%end

//******************** REGULAR **************************

%%define set
%name "reg_parser_s"
%type "reg_lalr_stack_s"
   %variable "lalr_stack"
%type "unsigned"
   %variable "fas_idx"
%type "fa_states_s"
   %variable "states"
%function "inline unsigned short process_char(char **ptr);"
%function "unsigned recognize_terminal(string_s &source_string,unsigned &input_idx,unsigned &line_cnt);"
%function "void parse_reg_exp(string_s &source_string);"
%function "void NKA_to_DKA();"
%function "inline void process_reg_exp(string_s &source_string);"
%function "void process_reg_exps(string_array_s &source_strings,fa_states_array_s &states_array);"
%%end

//*******************************************************

/*
 * string_arrays_s
 * p_sem_variable_names_array_s
 */

%%define array
%name "string_arrays_s"
%name "p_sem_variable_names_array_s"
%type "p_sem_variable_names_s"
%%end

/*
 * string_arrays_array_s
 */

%%define array
%name "string_arrays_array_s"
%type "string_arrays_s"
%%end

/*
 * p_sem_parse_data_s
 */

%%define set
%name "p_sem_parse_data_s"
%type "p_lalr_stack_s"
   %variable "lalr_stack"
%type "unsigned"
   %variable "var_type"
%type "p_sem_variable_names_array_s"
   %variable "sem_variable_names_array"
%type "ui_array_s"
   %variable "var_type_stack"
%type "p_sem_const_array_types_s"
   %variable "sem_const_array_types"

%type "pointer"
   %variable "source_string_ptr"

%type "ui_array_s"
   %variable "int_constants"
%type "string_array_s"
   %variable "string_constants"
%type "ui_arrays_s"
   %variable "int_array_constants"
%type "string_arrays_s"
   %variable "string_array_constants"
%type "ui_arrays_array_s"
   %variable "int_array_array_constants"
%type "string_arrays_array_s"
   %variable "string_array_array_constants"
%%end

/*
 * p_semantic_parser_s
 */

%%define set
%name "p_semantic_parser_s"
%type "unsigned"
   %variable "end_terminal"
%type "ui_array_s"
   %variable "skip_terminals"
%type "p_sem_rule_descrs_s"
   %variable "sem_rule_descrs"
%type "final_automata_s"
   %variable "final_automata"
%type "p_lalr_table_s"
   %variable "lalr_table"
%function "bool load_or_create(p_creat_descr_s &creat_descr);"

// - funkce implementujici semanticke programy, pri prekladu semantickych podprogramu -
%function "static void psi_stt_var_type_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_type_string(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_type_int_array(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_type_string_array(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_type_int_array_array(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_type_string_array_array(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_def(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_var_def_id(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_out(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_if_begin(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_if_end(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_if_else_end(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_if_else(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_do_while_end(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_do_while_begin(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_assert(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_exp_end(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_set(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_swap(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_and(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_or(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_compare(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_neg_compare(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_less(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_greater(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_less_equal(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_greater_equal(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_add(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_sub(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_conc(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_post_inc(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_post_dec(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_pre_inc(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_pre_dec(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_invertion(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_substr(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_format(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_get_rb(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_get_line_cnt(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_convert_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_convert_string(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_id(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_const_oct_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_const_dec_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_const_hex_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_const_char_int(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_const_str(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_blank_array(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_array_end(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_array_start(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_array_element(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_get_element(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_size_of(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_push_to(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_pop_from(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_remove_from(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_last_of(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_tail_of(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_get_idx(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%function "static void psi_stt_get_next_idx(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "static void psi_stt_const_apply(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"

%function "void parse_sem_string(buffer_s &sem_code,p_sem_parse_data_s &sem_parse_data);"
%fundef "save_file"
%fundef "load_file"
%%end

/*
 * p_rule_descr_s
 */

%%define set
%name "p_rule_descr_s"
%type "unsigned"
   %variable "ui_first"
%type "unsigned"
   %variable "ui_second"
%type "buffer_s"
   %variable "sem_code"
%%end

/*
 * p_rule_descrs_s
 */

%%define array
%name "p_rule_descrs_s"
%type "p_rule_descr_s"
%%end

/*
 * p_parse_data_s
 */

%%define set
%name "p_parse_data_s"
%type "p_lalr_stack_s"
   %variable "lalr_stack"
%type "ui_array_s"
   %variable "sem_run_stack"
%type "unsigned"
   %variable "action"
%type "unsigned"
   %variable "line_cnt"
%type "unsigned"
   %variable "sc_idx"

%type "pointer"
   %variable "source_string_ptr"
%type "pointer"
   %variable "parser_ptr"
%type "pointer"
   %variable "sem_code_ptr"

%type "ui_array_s"
   %variable "int_variables"
%type "string_array_s"
   %variable "string_variables"
%type "ui_arrays_s"
   %variable "int_array_variables"
%type "string_arrays_s"
   %variable "string_array_variables"
%type "ui_arrays_array_s"
   %variable "int_array_array_variables"
%type "string_arrays_array_s"
   %variable "string_array_array_variables"
%%end

/*
 * program_generator_s
 */

%%define set
%name "program_generator_s"
%type "ui_arrays_s"
   %variable "noterminal_rule_map"
%type "ui_array_s"
   %variable "create_stack_s"

%function "bool create_from_rule_string(string_s &rule_string);"

%%end

/*
 * parser_s
 */

%%define set
%name "parser_s"
%type "unsigned"
   %variable "terminal_cnt"
%type "unsigned"
   %variable "end_terminal"
%type "ui_array_s"
   %variable "skip_terminals"
%type "buffer_s"
   %variable "init_sem_code"
%type "p_rule_descrs_s"
   %variable "rule_descrs"
%type "ui_array_s"
   %variable "sem_variable_cnts"
%type "final_automata_s"
   %variable "final_automata"
%type "p_lalr_table_s"
   %variable "lalr_table"

%type "string_array_s"
   %variable "string_constants"
%type "ui_arrays_s"
   %variable "int_array_constants"
%type "string_arrays_s"
   %variable "string_array_constants"
%type "ui_arrays_array_s"
   %variable "int_array_array_constants"
%type "string_arrays_array_s"
   %variable "string_array_array_constants"

%function "bool create_from_rule_string(string_s &rule_string);"

%function "static void pi_sott_out_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_out_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_jump(p_parse_data_s &parse_data);"
%function "static void pi_sott_jump_if_zero(p_parse_data_s &parse_data);"
%function "static void pi_sott_jump_if_no_zero(p_parse_data_s &parse_data);"

%function "static void pi_sott_assert_int_value_string_const(p_parse_data_s &parse_data);"

%function "static void pi_sott_exp_end(p_parse_data_s &parse_data);"
%function "static void pi_sott_exp_end_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_exp_end_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_exp_end_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_exp_end_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_exp_end_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_set_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_var_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_var_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_var_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_var_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_var_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_var_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_var_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_var_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_var_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_var_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_array_var_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_array_var_int_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_array_var_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_array_var_string_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aref_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_aref_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_aref_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_aref_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_aref_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_array_aref_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_aref_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_aref_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_aref_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_aref_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_array_aref_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_int_aaref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aaref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aaref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aaref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aaref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_set_string_aaref_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_swap_string_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aref_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aaref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aaref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_aaref_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_int_array_var_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_int_array_var_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_int_array_aref_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_int_array_aref_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_array_var_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_array_var_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_array_aref_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_array_aref_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_int_array_array_var_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_swap_string_array_array_var_string_array_array_var(p_parse_data_s &parse_data);"

%function "static void pi_sott_logic_and_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_and_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_and_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_and_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_logic_or_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_or_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_or_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_logic_or_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_compare_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_var_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_var_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_var_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_var_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_var_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_var_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_var_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_var_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_var_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_var_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_array_var_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_array_var_int_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_array_var_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_array_var_string_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_tmp_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_tmp_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_tmp_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_tmp_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_tmp_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_tmp_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_tmp_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_tmp_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_tmp_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_tmp_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_tmp_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_tmp_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_tmp_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_const_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_const_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_const_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_const_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_const_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_const_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_const_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_const_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_const_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_const_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_const_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_const_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_const_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_array_const_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_array_const_int_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_array_const_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_array_const_string_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aref_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_aref_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_aref_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_aref_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_array_aref_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_aref_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_aref_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_aref_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_array_aref_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_int_aaref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aaref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aaref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aaref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aaref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_compare_string_aaref_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_less_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_greater_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_less_equal_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_equal_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_equal_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_less_equal_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_greater_equal_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_equal_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_equal_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_greater_equal_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_add_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_add_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_add_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_add_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_sub_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_sub_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_sub_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_sub_int_aaref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_conc_string_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_var_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_var_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_tmp_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_tmp_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_tmp_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_tmp_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_tmp_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_const_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_const_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_const_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_const_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_const_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aref_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aaref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aaref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aaref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aaref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_conc_string_aaref_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_post_inc_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_post_inc_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_post_inc_int_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_post_dec_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_post_dec_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_post_dec_int_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_pre_inc_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pre_inc_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_pre_inc_int_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_pre_dec_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pre_dec_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_pre_dec_int_aaref(p_parse_data_s &parse_data);"
   
%function "static void pi_sott_invertion_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_negation_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_substr_string_var_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_substr_string_tmp_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_substr_string_const_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_substr_string_aref_int_value_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_substr_string_aaref_int_value_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_format_string_var_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_format_string_tmp_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_format_string_const_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_format_string_aref_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_format_string_aaref_int_array_const(p_parse_data_s &parse_data);"

%function "static void pi_sott_get_rb_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_get_line_cnt(p_parse_data_s &parse_data);"

%function "static void pi_sott_convert_int_string_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_convert_int_string_tmp_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_convert_int_string_const_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_convert_int_string_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_convert_int_string_aaref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_convert_string_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_array_array_var(p_parse_data_s &parse_data);"

%function "static void pi_sott_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_int_array_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_string_array_array_const(p_parse_data_s &parse_data);"

%function "static void pi_sott_push_value_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_value_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_value_int_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_push_two_values_int_var_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aref_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aaref_int_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aaref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_var_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aref_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aaref_int_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_var_int_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aref_int_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_two_values_int_aaref_int_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_size_of_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_size_of_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_push_to_int_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_var_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_var_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_array_var_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_array_var_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_array_var_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_array_var_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_array_var_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_array_var_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_array_var_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_array_var_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_int_array_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_aref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_aref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_push_to_string_array_aref_string_aaref(p_parse_data_s &parse_data);"

%function "static void pi_sott_pop_from_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pop_from_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pop_from_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pop_from_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_pop_from_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_pop_from_string_array_aref(p_parse_data_s &parse_data);"
 
%function "static void pi_sott_remove_from_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_remove_from_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_remove_from_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_remove_from_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_remove_from_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_remove_from_string_array_aref(p_parse_data_s &parse_data);"

%function "static void pi_sott_last_of_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_last_of_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_last_of_int_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_last_of_string_array_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_last_of_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_last_of_string_array_aref(p_parse_data_s &parse_data);"

%function "static void pi_sott_tail_of_int_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_tail_of_string_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_tail_of_int_array_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_tail_of_string_array_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_tail_of_int_array_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_tail_of_string_array_aref_int_value(p_parse_data_s &parse_data);"

%function "static void pi_sott_get_idx_int_array_var_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_var_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_var_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_var_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_var_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_var_string_aaref(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_array_var_int_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_array_var_int_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_array_var_int_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_array_var_int_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_array_var_string_array_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_array_var_string_array_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_array_var_string_array_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_array_var_string_array_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_array_var_blank_array(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_int_array_aref_int_value(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_aref_string_var(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_aref_string_tmp(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_aref_string_const(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_aref_string_aref(p_parse_data_s &parse_data);"
%function "static void pi_sott_get_idx_string_array_aref_string_aaref(p_parse_data_s &parse_data);"

%function "void run_semantic_code(p_parse_data_s &parse_data);"
%function "void parse_source_string(string_s &source_string);"
%function "void create_cc_source(buffer_s &cc_source);"
%fundef "save_file"
%fundef "load_file"
%%end

